'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

class ExceptionBase extends Error {
    constructor(typeName, message, line = 0, column = 0) {
        const lineAndColumnText = line > 0 && column > 0 ? ` at line ${line}, column ${column}` : '';
        const str = `${typeName}${lineAndColumnText}: ${message}`;
        super(str);
        this.str = str;
        this.line = line;
        this.column = column;
    }
    toString() {
        return this.str;
    }
}

class ArgumentException extends ExceptionBase {
    constructor(message, argumentName, line = 0, column = 0) {
        super('ArgumentException', message, line, column);
        this.argumentName = argumentName;
        this.argumentName = argumentName;
    }
}

class EvaluationException extends ExceptionBase {
    constructor(message, line = 0, column = 0) {
        super('EvaluationException', message, line, column);
    }
}

class GrammarException extends ExceptionBase {
    constructor(message, line = 0, column = 0) {
        super('GrammarException', message, line, column);
    }
}

var n,t,e,a,r;!function(n){n[n.UndefinedSymbol=0]="UndefinedSymbol",n[n.Lambda=1]="Lambda",n[n.Dot=2]="Dot",n[n.terminalBegin=3]="terminalBegin",n[n.terminalEnd=4]="terminalEnd",n[n.terminalAssign=5]="terminalAssign",n[n.terminalSemicolon=6]="terminalSemicolon",n[n.terminalRead=7]="terminalRead",n[n.terminalWrite=8]="terminalWrite",n[n.terminalLeftBracket=9]="terminalLeftBracket",n[n.terminalRightBracket=10]="terminalRightBracket",n[n.terminalLeftSquareBracket=11]="terminalLeftSquareBracket",n[n.terminalRightSquareBracket=12]="terminalRightSquareBracket",n[n.terminalOrBar=13]="terminalOrBar",n[n.terminalComma=14]="terminalComma",n[n.terminalID=15]="terminalID",n[n.terminalVariable=16]="terminalVariable",n[n.terminalIntegerLiteral=17]="terminalIntegerLiteral",n[n.terminalFloatLiteral=18]="terminalFloatLiteral",n[n.terminalStringLiteral=19]="terminalStringLiteral",n[n.terminalPlus=20]="terminalPlus",n[n.terminalMinus=21]="terminalMinus",n[n.terminalCond=22]="terminalCond",n[n.terminalLet=23]="terminalLet",n[n.terminalLetStar=24]="terminalLetStar",n[n.terminalDefine=25]="terminalDefine",n[n.terminalIf=26]="terminalIf",n[n.terminalWhile=27]="terminalWhile",n[n.terminalSet=28]="terminalSet",n[n.terminalMultiply=29]="terminalMultiply",n[n.terminalDivide=30]="terminalDivide",n[n.terminalEquals=31]="terminalEquals",n[n.terminalLessThan=32]="terminalLessThan",n[n.terminalGreaterThan=33]="terminalGreaterThan",n[n.terminalPrint=34]="terminalPrint",n[n.terminalCons=35]="terminalCons",n[n.terminalCar=36]="terminalCar",n[n.terminalCdr=37]="terminalCdr",n[n.terminalNumberPred=38]="terminalNumberPred",n[n.terminalSymbolPred=39]="terminalSymbolPred",n[n.terminalListPred=40]="terminalListPred",n[n.terminalNullPred=41]="terminalNullPred",n[n.terminalStringPred=42]="terminalStringPred",n[n.terminalApostrophe=43]="terminalApostrophe",n[n.terminalDot=44]="terminalDot",n[n.terminalList=45]="terminalList",n[n.terminalRplaca=46]="terminalRplaca",n[n.terminalRplacd=47]="terminalRplacd",n[n.terminalDefineMacro=48]="terminalDefineMacro",n[n.terminalQuoteKeyword=49]="terminalQuoteKeyword",n[n.terminalRandom=50]="terminalRandom",n[n.terminalToString=51]="terminalToString",n[n.terminalListToString=52]="terminalListToString",n[n.terminalStringToList=53]="terminalStringToList",n[n.terminalStringToSymbol=54]="terminalStringToSymbol",n[n.terminalSin=55]="terminalSin",n[n.terminalCos=56]="terminalCos",n[n.terminalTan=57]="terminalTan",n[n.terminalPow=58]="terminalPow",n[n.terminalExp=59]="terminalExp",n[n.terminalLn=60]="terminalLn",n[n.terminalFloor=61]="terminalFloor",n[n.terminalAtan2=62]="terminalAtan2",n[n.terminalThrow=63]="terminalThrow",n[n.terminalStringLessThan=64]="terminalStringLessThan",n[n.terminalPrimOpPred=65]="terminalPrimOpPred",n[n.terminalClosurePred=66]="terminalClosurePred",n[n.terminalLambdaKeyword=67]="terminalLambdaKeyword",n[n.terminalLetRec=68]="terminalLetRec",n[n.terminalCallCC=69]="terminalCallCC",n[n.terminalNameBeginningWithCapital=70]="terminalNameBeginningWithCapital",n[n.terminalNameNotBeginningWithCapital=71]="terminalNameNotBeginningWithCapital",n[n.terminalFrom=72]="terminalFrom",n[n.terminalInferPred=73]="terminalInferPred",n[n.terminalNotSymbol=74]="terminalNotSymbol",n[n.terminalIs=75]="terminalIs",n[n.terminalLessOrEqual=76]="terminalLessOrEqual",n[n.terminalGreaterOrEqual=77]="terminalGreaterOrEqual",n[n.terminalNotEqual=78]="terminalNotEqual",n[n.terminalArithmeticEqual=79]="terminalArithmeticEqual",n[n.terminalArithmeticNotEqual=80]="terminalArithmeticNotEqual",n[n.terminalUnifiable=81]="terminalUnifiable",n[n.terminalNotUnifiable=82]="terminalNotUnifiable",n[n.terminalIfThen=83]="terminalIfThen",n[n.terminalColon=84]="terminalColon",n[n.terminalDCGArrow=85]="terminalDCGArrow",n[n.terminalUniv=86]="terminalUniv",n[n.terminalCaret=87]="terminalCaret",n[n.terminalFn=88]="terminalFn",n[n.terminalThickArrow=89]="terminalThickArrow",n[n.terminalIn=90]="terminalIn",n[n.terminalTrue=91]="terminalTrue",n[n.terminalFalse=92]="terminalFalse",n[n.terminalComb=93]="terminalComb",n[n.terminalInc=94]="terminalInc",n[n.terminalDec=95]="terminalDec",n[n.terminalAnd=96]="terminalAnd",n[n.terminalOr=97]="terminalOr",n[n.terminalIsZero=98]="terminalIsZero",n[n.terminalNil=99]="terminalNil",n[n.terminalOctothorpe=100]="terminalOctothorpe",n[n.terminalDollar=101]="terminalDollar",n[n.terminalClass=102]="terminalClass",n[n.terminalObjectPred=103]="terminalObjectPred",n[n.terminalStrlen=104]="terminalStrlen",n[n.terminalSubstr=105]="terminalSubstr",n[n.terminalTypename=106]="terminalTypename",n[n.terminalStrcat=107]="terminalStrcat",n[n.terminalNewArray=108]="terminalNewArray",n[n.terminalArrayLength=109]="terminalArrayLength",n[n.terminalArrayGet=110]="terminalArrayGet",n[n.terminalArraySet=111]="terminalArraySet",n[n.terminalArrayPred=112]="terminalArrayPred",n[n.terminalCharPred=113]="terminalCharPred",n[n.terminalStringIndex=114]="terminalStringIndex",n[n.terminalVectorConst=115]="terminalVectorConst",n[n.terminalMax=116]="terminalMax",n[n.terminalPlusSlash=117]="terminalPlusSlash",n[n.terminalMinusSlash=118]="terminalMinusSlash",n[n.terminalMultiplySlash=119]="terminalMultiplySlash",n[n.terminalDivideSlash=120]="terminalDivideSlash",n[n.terminalMaxSlash=121]="terminalMaxSlash",n[n.terminalOrSlash=122]="terminalOrSlash",n[n.terminalAndSlash=123]="terminalAndSlash",n[n.terminalCompress=124]="terminalCompress",n[n.terminalShape=125]="terminalShape",n[n.terminalRavel=126]="terminalRavel",n[n.terminalRestruct=127]="terminalRestruct",n[n.terminalCat=128]="terminalCat",n[n.terminalIndx=129]="terminalIndx",n[n.terminalTrans=130]="terminalTrans",n[n.terminalSquareBrackets=131]="terminalSquareBrackets",n[n.terminalDoubleSubscripting=132]="terminalDoubleSubscripting",n[n.terminalCluster=133]="terminalCluster",n[n.terminalRep=134]="terminalRep",n[n.terminalExport=135]="terminalExport",n[n.terminalEOF=136]="terminalEOF",n[n.nonterminalStart=137]="nonterminalStart",n[n.nonterminalProgram=138]="nonterminalProgram",n[n.nonterminalStatementList=139]="nonterminalStatementList",n[n.nonterminalStatementTail=140]="nonterminalStatementTail",n[n.nonterminalStatement=141]="nonterminalStatement",n[n.nonterminalIDList=142]="nonterminalIDList",n[n.nonterminalIDTail=143]="nonterminalIDTail",n[n.nonterminalExprList=144]="nonterminalExprList",n[n.nonterminalExprTail=145]="nonterminalExprTail",n[n.nonterminalExpression=146]="nonterminalExpression",n[n.nonterminalTerm=147]="nonterminalTerm",n[n.nonterminalPrimaryTail=148]="nonterminalPrimaryTail",n[n.nonterminalPrimary=149]="nonterminalPrimary",n[n.nonterminalAddOp=150]="nonterminalAddOp",n[n.nonterminalBracketedEntity=151]="nonterminalBracketedEntity",n[n.nonterminalInput=152]="nonterminalInput",n[n.nonterminalFunDef=153]="nonterminalFunDef",n[n.nonterminalFunction=154]="nonterminalFunction",n[n.nonterminalArgList=155]="nonterminalArgList",n[n.nonterminalVariableList=156]="nonterminalVariableList",n[n.nonterminalVariable=157]="nonterminalVariable",n[n.nonterminalValue=158]="nonterminalValue",n[n.nonterminalBracketedExpression=159]="nonterminalBracketedExpression",n[n.nonterminalExpressionList=160]="nonterminalExpressionList",n[n.nonterminalOptr=161]="nonterminalOptr",n[n.nonterminalValueOp=162]="nonterminalValueOp",n[n.nonterminalQuotedConst=163]="nonterminalQuotedConst",n[n.nonterminalSExpression=164]="nonterminalSExpression",n[n.nonterminalSExpressionList=165]="nonterminalSExpressionList",n[n.nonterminalSymbol=166]="nonterminalSymbol",n[n.nonterminalMacroDef=167]="nonterminalMacroDef",n[n.nonterminalExprPairList=168]="nonterminalExprPairList",n[n.nonterminalLetKeyword=169]="nonterminalLetKeyword",n[n.nonterminalVarExprList=170]="nonterminalVarExprList",n[n.nonterminalBracketedInput=171]="nonterminalBracketedInput",n[n.nonterminalUnbracketedInput=172]="nonterminalUnbracketedInput",n[n.nonterminalSExpressionListTail=173]="nonterminalSExpressionListTail",n[n.nonterminalClause=174]="nonterminalClause",n[n.nonterminalQuery=175]="nonterminalQuery",n[n.nonterminalGoal=176]="nonterminalGoal",n[n.nonterminalClauseTail=177]="nonterminalClauseTail",n[n.nonterminalGoalList=178]="nonterminalGoalList",n[n.nonterminalGoalListTail=179]="nonterminalGoalListTail",n[n.nonterminalList=180]="nonterminalList",n[n.nonterminalListContents=181]="nonterminalListContents",n[n.nonterminalListContentsTail=182]="nonterminalListContentsTail",n[n.nonterminalFunctorExpression=183]="nonterminalFunctorExpression",n[n.nonterminalTailOfGoalOrFunctorExpression=184]="nonterminalTailOfGoalOrFunctorExpression",n[n.nonterminalExpressionListTail=185]="nonterminalExpressionListTail",n[n.nonterminalGoalTail1=186]="nonterminalGoalTail1",n[n.nonterminalVariableOrNumericLiteral=187]="nonterminalVariableOrNumericLiteral",n[n.nonterminalLambdaExpression=188]="nonterminalLambdaExpression",n[n.nonterminalLetStatement=189]="nonterminalLetStatement",n[n.nonterminalFunctionCall=190]="nonterminalFunctionCall",n[n.nonterminalAfterVariable=191]="nonterminalAfterVariable",n[n.nonterminalClassDef=192]="nonterminalClassDef",n[n.nonterminalClass=193]="nonterminalClass",n[n.nonterminalInstVars=194]="nonterminalInstVars",n[n.nonterminalMethodDef=195]="nonterminalMethodDef",n[n.nonterminalMethodDefList=196]="nonterminalMethodDefList",n[n.nonterminalLiteralList=197]="nonterminalLiteralList",n[n.nonterminalVectorConst=198]="nonterminalVectorConst",n[n.nonterminalIntegerLiteralList=199]="nonterminalIntegerLiteralList",n[n.nonterminalClusterDef=200]="nonterminalClusterDef",n[n.nonterminalRep=201]="nonterminalRep",n[n.nonterminalFunDefList=202]="nonterminalFunDefList",n[n.nonterminalOnePartName=203]="nonterminalOnePartName",n[n.nonterminalOnePartNameTail=204]="nonterminalOnePartNameTail",n[n.nonterminalExportList=205]="nonterminalExportList",n[n.nonterminalOnePartNameList=206]="nonterminalOnePartNameList",n[n.nonterminalArithmeticExpression=207]="nonterminalArithmeticExpression",n[n.nonterminalArithmeticExpression1=208]="nonterminalArithmeticExpression1",n[n.nonterminalArithmeticExpression2=209]="nonterminalArithmeticExpression2",n[n.nonterminalArithmeticExpression3=210]="nonterminalArithmeticExpression3",n[n.nonterminalArithmeticExpression4=211]="nonterminalArithmeticExpression4",n[n.nonterminalArithmeticOperator=212]="nonterminalArithmeticOperator",n[n.nonterminalArithmeticOperator1=213]="nonterminalArithmeticOperator1",n[n.nonterminalArithmeticOperator2=214]="nonterminalArithmeticOperator2",n[n.nonterminalArithmeticOperator3=215]="nonterminalArithmeticOperator3",n[n.nonterminalArithmeticOperator4=216]="nonterminalArithmeticOperator4",n[n.nonterminalArithmeticComparisonOperator=217]="nonterminalArithmeticComparisonOperator";}(n||(n={})),function(n){n[n.MinimalLanguage=0]="MinimalLanguage",n[n.Micro=1]="Micro",n[n.Chapter1=2]="Chapter1",n[n.LISP=3]="LISP",n[n.APL=4]="APL",n[n.Scheme=5]="Scheme",n[n.SASL=6]="SASL",n[n.CLU=7]="CLU",n[n.Smalltalk=8]="Smalltalk",n[n.Prolog=9]="Prolog",n[n.Prolog2=10]="Prolog2",n[n.Inference=11]="Inference",n[n.JSON=12]="JSON",n[n.EcstaSKI=13]="EcstaSKI",n[n.Adso=14]="Adso",n[n.LambdaCalculus=15]="LambdaCalculus",n[n.LambdaCalculusWithAugmentedSyntax=16]="LambdaCalculusWithAugmentedSyntax",n[n.LambdaCalculusIntegerExtension=17]="LambdaCalculusIntegerExtension",n[n.C=18]="C",n[n.N1=19]="N1",n[n.Arithmetic=20]="Arithmetic";}(t||(t={})),function(n){n[n.MidnightHack=1]="MidnightHack",n[n.FiniteStateMachine=2]="FiniteStateMachine";}(e||(e={})),function(n){n[n.tokenNone=1]="tokenNone",n[n.tokenIntLit=2]="tokenIntLit",n[n.tokenFltLit=3]="tokenFltLit",n[n.tokenStrLit=4]="tokenStrLit",n[n.tokenStrLit2=5]="tokenStrLit2",n[n.tokenIdent=6]="tokenIdent",n[n.tokenBoolIdent=7]="tokenBoolIdent",n[n.tokenSkolemIdent=8]="tokenSkolemIdent",n[n.tokenVariable=9]="tokenVariable",n[n.tokenMult=10]="tokenMult",n[n.tokenDiv=11]="tokenDiv",n[n.tokenPlus=12]="tokenPlus",n[n.tokenMinus=13]="tokenMinus",n[n.tokenEqual=14]="tokenEqual",n[n.tokenNotEqual=15]="tokenNotEqual",n[n.tokenLess=16]="tokenLess",n[n.tokenLessEqual=17]="tokenLessEqual",n[n.tokenGreater=18]="tokenGreater",n[n.tokenGreaterEqual=19]="tokenGreaterEqual",n[n.tokenSemicolon=20]="tokenSemicolon",n[n.tokenComma=21]="tokenComma",n[n.token2OrBar=22]="token2OrBar",n[n.token2Ampersand=23]="token2Ampersand",n[n.tokenLeftBracket=24]="tokenLeftBracket",n[n.tokenRightBracket=25]="tokenRightBracket",n[n.tokenAssign=26]="tokenAssign",n[n.tokenArrow=27]="tokenArrow",n[n.tokenThickArrow=28]="tokenThickArrow",n[n.tokenExclamation=29]="tokenExclamation",n[n.tokenApostrophe=30]="tokenApostrophe",n[n.tokenOctothorpe=31]="tokenOctothorpe",n[n.tokenDollar=32]="tokenDollar",n[n.tokenDot=33]="tokenDot",n[n.tokenLeftSquareBracket=34]="tokenLeftSquareBracket",n[n.tokenRightSquareBracket=35]="tokenRightSquareBracket",n[n.tokenOrBar=36]="tokenOrBar",n[n.tokenColon=37]="tokenColon",n[n.tokenLeftCurlyBrace=38]="tokenLeftCurlyBrace",n[n.tokenRightCurlyBrace=39]="tokenRightCurlyBrace",n[n.tokenQuoteKeyword=40]="tokenQuoteKeyword",n[n.tokenQuestionMinus=41]="tokenQuestionMinus",n[n.tokenColonMinus=42]="tokenColonMinus",n[n.tokenEqualLessThan=43]="tokenEqualLessThan",n[n.tokenBackslashPlus=44]="tokenBackslashPlus",n[n.tokenBackslashEqual=45]="tokenBackslashEqual",n[n.tokenEqualEqual=46]="tokenEqualEqual",n[n.tokenBackslashEqualEqual=47]="tokenBackslashEqualEqual",n[n.tokenEqualColonEqual=48]="tokenEqualColonEqual",n[n.tokenEqualBackslashEqual=49]="tokenEqualBackslashEqual",n[n.tokenMinusMinusGreaterThan=50]="tokenMinusMinusGreaterThan",n[n.tokenEqualDotDot=51]="tokenEqualDotDot",n[n.tokenCaret=52]="tokenCaret",n[n.tokenLowercaseGreekLetterLambda=53]="tokenLowercaseGreekLetterLambda",n[n.tokenEOF=54]="tokenEOF",n[n.stateStart=55]="stateStart",n[n.stateError=56]="stateError",n[n.stateStrLitOpen=57]="stateStrLitOpen",n[n.stateStrLit2Open=58]="stateStrLit2Open",n[n.stateIntLitDot=59]="stateIntLitDot",n[n.stateQuestion=60]="stateQuestion",n[n.stateAmpersand=61]="stateAmpersand",n[n.stateAt=62]="stateAt",n[n.stateDollar=63]="stateDollar",n[n.stateBackslash=64]="stateBackslash",n[n.stateEqualColon=65]="stateEqualColon",n[n.stateEqualBackslash=66]="stateEqualBackslash",n[n.stateMinusMinus=67]="stateMinusMinus",n[n.stateEqualDot=68]="stateEqualDot";}(a||(a={})),function(n){n[n.LL1=0]="LL1",n[n.LR0=1]="LR0",n[n.LR1=2]="LR1",n[n.SLR1=3]="SLR1",n[n.LALR1=4]="LALR1";}(r||(r={}));

class Name {
    constructor(value, line = 0, column = 0) {
        this.value = value;
        this.line = line;
        this.column = column;
        if (!value) {
            throw new ArgumentException('Name constructor: A Name cannot have a null or empty value', 'value');
        }
    }
    toString() {
        return this.value;
    }
}

const typenameProduction = 'Production';
function isProduction(obj) {
    const otherProduction = obj;
    const lhs = otherProduction.lhs;
    const rhs = otherProduction.rhs;
    return (typeof otherProduction !== 'undefined' &&
        otherProduction.typename === typenameProduction &&
        typeof lhs !== 'undefined' &&
        typeof lhs === 'number' &&
        typeof rhs !== 'undefined' &&
        rhs instanceof Array &&
        rhs.every((element) => typeof element === 'number' || typeof element === 'string'));
}
class Production {
    constructor(lhs, rhs, num) {
        this.lhs = lhs;
        this.rhs = rhs;
        this.num = num;
        this.typename = typenameProduction;
    }
    toString() {
        const lhsAsString = n[this.lhs];
        const rhsAsString = this.rhs
            .map((s) => {
            if (typeof s === 'string') {
                return s;
            }
            else {
                return n[s];
            }
        })
            .join(' ');
        return `${this.num}: ${lhsAsString} -> ${rhsAsString}`;
    }
    equals(other) {
        return (isProduction(other) &&
            other.lhs === this.lhs &&
            other.rhs.length === this.rhs.length &&
            other.rhs.every((obj, i) => obj === this.rhs[i]));
    }
    getRHSWithNoSemanticActions() {
        return this.rhs
            .filter((s) => typeof s !== 'string')
            .map((s) => s);
    }
    stripOutSemanticActions() {
        return new Production(this.lhs, this.getRHSWithNoSemanticActions(), this.num);
    }
    containsSymbol(symbol) {
        return (this.lhs === symbol ||
            typeof this.rhs.find((s) => s === symbol) !== 'undefined');
    }
}
function createProduction(lhs, rhs, num = 0) {
    return new Production(lhs, rhs, num);
}

class GrammarBase {
    constructor(startSymbol) {
        this.startSymbol = startSymbol;
        this.terminals = [];
        this.nonTerminals = [];
        this.productions = [];
    }
    get defaultLexicalAnalyzer() {
        return e.MidnightHack;
    }
    get defaultParser() {
        return r.LL1;
    }
    get selectorsOfCompatibleParsers() {
        return [this.defaultParser];
    }
    tokenToSymbol(token) {
        const tokenValueAsString = token.tokenValue;
        switch (token.tokenType) {
            case a.tokenEOF:
                return n.terminalEOF;
            case a.tokenIntLit:
                return n.terminalIntegerLiteral;
            case a.tokenFltLit:
                return n.terminalFloatLiteral;
            case a.tokenStrLit:
                return n.terminalStringLiteral;
            case a.tokenPlus:
                return n.terminalPlus;
            case a.tokenMinus:
                return n.terminalMinus;
            case a.tokenMult:
                return n.terminalMultiply;
            case a.tokenDiv:
                return n.terminalDivide;
            case a.tokenEqual:
                return n.terminalEquals;
            case a.tokenLess:
                return n.terminalLessThan;
            case a.tokenGreater:
                return n.terminalGreaterThan;
            case a.tokenLeftBracket:
                return n.terminalLeftBracket;
            case a.tokenRightBracket:
                return n.terminalRightBracket;
            case a.tokenApostrophe:
                return n.terminalApostrophe;
            case a.tokenComma:
                return n.terminalComma;
            case a.tokenDollar:
                return n.terminalDollar;
            case a.tokenOctothorpe:
                return n.terminalOctothorpe;
            case a.tokenIdent:
                switch (tokenValueAsString) {
                    case 'define':
                        return n.terminalDefine;
                    case 'if':
                        return n.terminalIf;
                    case 'while':
                        return n.terminalWhile;
                    case 'set':
                        return n.terminalSet;
                    case 'begin':
                        return n.terminalBegin;
                    case 'print':
                        return n.terminalPrint;
                    case 'cond':
                        return n.terminalCond;
                    case 'let':
                        return n.terminalLet;
                    case 'let*':
                        return n.terminalLetStar;
                    case 'random':
                        return n.terminalRandom;
                    case 'pow':
                        return n.terminalPow;
                    case 'exp':
                        return n.terminalExp;
                    case 'ln':
                        return n.terminalLn;
                    case 'sin':
                        return n.terminalSin;
                    case 'cos':
                        return n.terminalCos;
                    case 'tan':
                        return n.terminalTan;
                    default:
                        return n.terminalID;
                }
            default:
                throw new GrammarException(`GrammarBase.tokenToSymbol() : No grammar symbol matches token ${token.tokenType} ${a[token.tokenType]} (value '${token.tokenValue}')`, token.line, token.column);
        }
    }
    pushTokenOntoSemanticStack(semanticStack, tokenAsSymbol, token) {
        switch (tokenAsSymbol) {
            case n.terminalID:
            case n.terminalPrint:
            case n.terminalPlus:
            case n.terminalMinus:
            case n.terminalMultiply:
            case n.terminalDivide:
            case n.terminalEquals:
            case n.terminalLessThan:
            case n.terminalGreaterThan:
            case n.terminalLet:
            case n.terminalLetStar:
            case n.terminalRandom:
            case n.terminalPow:
            case n.terminalExp:
            case n.terminalLn:
            case n.terminalSin:
            case n.terminalCos:
            case n.terminalTan:
            case n.terminalThrow:
                semanticStack.push(new Name(token.tokenValue, token.line, token.column));
                break;
            case n.terminalLeftBracket:
            case n.terminalRightBracket:
            case n.terminalBegin:
            case n.terminalCond:
            case n.terminalDefine:
            case n.terminalIf:
            case n.terminalSet:
            case n.terminalWhile:
            case n.terminalEOF:
                break;
            default:
                throw new GrammarException(`pushTokenOntoSemanticStack() : Unexpected tokenAsSymbol ${n[tokenAsSymbol]} (${tokenAsSymbol})`, token.line, token.column);
        }
    }
    findStartingProduction() {
        const results = [];
        for (const p of this.productions) {
            if (p.lhs === this.startSymbol) {
                const p2 = p.stripOutSemanticActions();
                if (p2.rhs.length > 0) {
                    const lastObject = p2.rhs[p2.rhs.length - 1];
                    if (lastObject === n.terminalEOF) {
                        results.push(p2);
                    }
                }
            }
        }
        if (results.length !== 1) {
            throw new GrammarException(`GrammarBase.FindStartingProduction() : Expected one starting production; found ${results.length}.`);
        }
        return results[0];
    }
    addProduction(lhs, rhs, n = NaN) {
        this.productions.push(createProduction(lhs, rhs, Number.isNaN(n) ? this.productions.length + 1 : n));
    }
}

exports.ArgumentException = ArgumentException;
exports.EvaluationException = EvaluationException;
exports.ExceptionBase = ExceptionBase;
exports.GrammarBase = GrammarBase;
exports.GrammarException = GrammarException;
exports.Name = Name;
exports.createProduction = createProduction;
exports.isProduction = isProduction;
